<?php

define('AWS_ACCESS_KEY_ID',     'lZbgĂ!!');
define('AWS_SECRET_ACCESS_KEY', 'lZbgĂ!!');  
define('MERCHANT_ID',           'lZbgĂ!!');
define('MARKETPLACE_ID',        'lZbgĂ!!');

set_include_path( get_include_path() . PATH_SEPARATOR . 'MarketplaceWebServiceProducts/.' );    


// C̎s
main();

//****************************************************************************
// Function		: main
// Description	: C
//****************************************************************************
function main() {

	//--------------------------------
	// WebT[rX̎擾
	//--------------------------------
	$service = getService();
	//P̃eXgp(MarketplaceWebServiceProducts/Mockxmlt@Cgp)
	//$service = new MarketplaceWebServiceProducts_Mock();


	//-------------------------------
	// NGXgp[^̃Zbg
	//-------------------------------
	$asinList = new MarketplaceWebServiceProducts_Model_ASINListType();
	$asinList->setASIN( array( '4478312141', '4797330058' ) );
	
	$request = new MarketplaceWebServiceProducts_Model_GetLowestOfferListingsForASINRequest();
	$request->setSellerId( MERCHANT_ID );
	$request->setMarketplaceId( MARKETPLACE_ID );
	$request->setASINList( $asinList );


	//-------------------------------
	// MWSNGXgAPI̎s
	//-------------------------------
	try {
	    $response = $service->getLowestOfferListingsForASIN($request);
	} catch (MarketplaceWebServiceProducts_Exception $ex) {
	    echo("Caught Exception: "       . $ex->getMessage()    . "\n");
	    echo("Response Status Code: "   . $ex->getStatusCode() . "\n");
	    echo("Error Code: "             . $ex->getErrorCode() . "\n");
	    echo("Error Type: "             . $ex->getErrorType() . "\n");
	    echo("Request ID: "             . $ex->getRequestId() . "\n");
	    echo("XML: "                    . $ex->getXML() . "\n");
	    echo("ResponseHeaderMetadata: " . $ex->getResponseHeaderMetadata() . "\n");
	}

	//-------------------------------
	// API\
	//-------------------------------
	showResponse( $response );
}



//****************************************************************************
// Function		: getService
// Description	: WebT[rX̎擾
// Return		: MarketplaceWebServiceProducts_Client	T[rX
//****************************************************************************
function getService() {

	//---------------------------------
	// NX̃I[g[fBOs
	//---------------------------------
	function __autoload($className){
	    $filePath = str_replace('_', DIRECTORY_SEPARATOR, $className) . '.php';
	    $includePaths = explode(PATH_SEPARATOR, get_include_path());
	    foreach($includePaths as $includePath){
	        if(file_exists($includePath . DIRECTORY_SEPARATOR . $filePath)){
	            require_once $filePath;
	            return;
	        }
	    }
	}

	// Web APĨGh|Cg(japan)
	$serviceUrl = "https://mws.amazonservices.jp/Products/2011-10-01";

	// proxy/retry̐ݒ
	$config = array (
	   'ServiceURL'    => $serviceUrl,
	   'ProxyHost'     => null,
	   'ProxyPort'     => -1,
	   'MaxErrorRetry' => 3,
	);

	// WebT[rXIuWFNg𐶐
	$service = new MarketplaceWebServiceProducts_Client(
			    AWS_ACCESS_KEY_ID,
			    AWS_SECRET_ACCESS_KEY,
			    'nanoappli.com_SampleApp',
			    '1.0.0.0',
			    $config);
			    
	return $service;
}



//****************************************************************************
// Function		: showResponse
// Description	: WebT[rXsʂ̕\
// Params		: $response	WebAPIs
//****************************************************************************
function showResponse( $response ) {
	$getLowestOfferListingsForASINResultList = $response->getGetLowestOfferListingsForASINResult();

	//--------------------------------------
	// SĂASIN\܂ŌJԂ
	//--------------------------------------
	foreach ($getLowestOfferListingsForASINResultList as $getLowestOfferListingsForASINResult) {
		echo ("=============================================================================\n");

		// 
		if ($getLowestOfferListingsForASINResult->isSetStatus()) {
		    echo( "Status :" . $getLowestOfferListingsForASINResult->getStatus() . "\n");
		}


		//----------------
    	// ȉ
		//----------------
		if ($getLowestOfferListingsForASINResult->isSetASIN()) {
		    echo( "ASIN   :" . $getLowestOfferListingsForASINResult->getASIN() . "\n");
		}
	    if ($getLowestOfferListingsForASINResult->isSetProduct()) { 
	        $product = $getLowestOfferListingsForASINResult->getProduct();			
	        if ($product->isSetSalesRankings()) { 
	            $salesRankings = $product->getSalesRankings();
	            $salesRankList = $salesRankings->getSalesRank();
	            foreach ($salesRankList as $salesRank) {
	                if ($salesRank->isSetProductCategoryId()) {
	                    echo("JeSID :" . $salesRank->getProductCategoryId() . "\n");
	                }
	                if ($salesRank->isSetRank()) {
	                    echo("N :" . $salesRank->getRank() . "\n");
	                }
	            }
	        } 
	        
	        //-------------------
	        // oi
	        //-------------------
	        if ($product->isSetLowestOfferListings()) { 
	            $lowestOfferListings = $product->getLowestOfferListings();
	            $lowestOfferListingList = $lowestOfferListings->getLowestOfferListing();

				//-----------------------------------------
				// 擾Soi\܂ŌJԂ
				//-----------------------------------------
	            foreach ($lowestOfferListingList as $lowestOfferListing) {
		        	echo( "------------------------------------------------\n" );

	                //------------------
	            	// ȉ
	                //------------------
	                if ($lowestOfferListing->isSetQualifiers()) { 
	                    $qualifiers = $lowestOfferListing->getQualifiers();
	                    if ($qualifiers->isSetItemCondition()) {
	                    	$condName    = getConditionName( $qualifiers->getItemCondition() );
	                    	$subCondName = "";
		                    if ($qualifiers->isSetItemSubcondition()) {
			                    $subCondName = "(" . getItemSubconditionName( $qualifiers->getItemSubcondition() ) . ")";
		                    }
	                        echo("RfBV   :" . $condName . $subCondName . "\n" );
	                    }
	                    
	                    
	                    if ($qualifiers->isSetFulfillmentChannel()) {
	                    	$name = getFulfillmentChannelName( $qualifiers->getFulfillmentChannel() );
	                        echo("o׌           :" . $name . "\n");
	                    }
	                    if ($qualifiers->isSetShipsDomestically()) {
	                        echo("蔭     :" . $qualifiers->getShipsDomestically() . "\n");
	                    }
	                    if ($qualifiers->isSetShippingTime()) { 
	                        $shippingTime = $qualifiers->getShippingTime();
	                        if ($shippingTime->isSetMax()) {
	                            echo("(ő)   :" . $shippingTime->getMax() . "\n");
	                        }
	                    } 

		                if ($lowestOfferListing->isSetSellerFeedbackCount()) {
		                    echo("tB[hobN :" . $lowestOfferListing->getSellerFeedbackCount() );

		                    if ($qualifiers->isSetSellerPositiveFeedbackRating()) {
		                        echo(" (]:" . $qualifiers->getSellerPositiveFeedbackRating() . ")");
		                    }
		                    echo ( "\n" );
		                }
	                }
	                if ($lowestOfferListing->isSetNumberOfOfferListingsConsidered()) {
	                    echo("oi           :" . $lowestOfferListing->getNumberOfOfferListingsConsidered() . "\n");
	                }

	                //------------------
	                // i
	                //------------------
	                if ($lowestOfferListing->isSetPrice()) { 
	                    $price1 = $lowestOfferListing->getPrice();
	                    if ($price1->isSetLandedPrice()) { 
	                        echo("z             :" . getPriceName( $price1->getLandedPrice() ) );
	                        
	                    } 
	                    if ($price1->isSetShipping()) { 
	                        echo(" (:" . getPriceName( $price1->getShipping() ) . ")" );
	                    } 
                        echo ( "\n" );
	                } 
	            }
	        } 
	    } 
	    
	    if ($getLowestOfferListingsForASINResult->isSetError()) { 
	        echo("G[܂\n");
	        $error = $getLowestOfferListingsForASINResult->getError();
	        if ($error->isSetType()) {
	            echo("Type:" . $error->getType() . "\n");
	        }
	        if ($error->isSetCode()) {
	            echo("Code:" . $error->getCode() . "\n");
	        }
	        if ($error->isSetMessage()) {
	            echo("Message:" . $error->getMessage() . "\n");
	        }
	    } 
	}
}


//****************************************************************************
// Function		: getConditionName
// Description	: RfBV({)擾
//****************************************************************************
function getConditionName( $inStr ) {
	switch( $inStr ) {
		case "New":
			return "Vi";
			break;
		case "Used":
			return "Õi";
			break;
		case "Collectible":
			return "RN^[i";
			break;
		case "Refurbished":
			return "Đi";
			break;
		default:
			return $inStr;
			break;
	}
}


//****************************************************************************
// Function		: getItemSubconditionName
// Description	: TuRfBV({)擾
//****************************************************************************
function getItemSubconditionName( $inStr ) {
	switch( $inStr ) {
		case "New":
			return "Vi";
			break;
		case "Mint":
			return "قڐVi";
			break;
		case "Very Good":
		case "VeryGood":
			return "ɗǂ";
			break;
		case "Good":
			return "ǂ";
			break;
		default:
			return $inStr;
			break;
	}
}


//****************************************************************************
// Function		: getFulfillmentChannelName
// Description	: o׌({)擾
//****************************************************************************
function getFulfillmentChannelName( $inStr ) {
	switch( $inStr ) {
		case "Amazon":
			return "FBA";
			break;
		case "Merchant":
			return "oi";
			break;
		default:
			return $inStr;
			break;
	}
}


//****************************************************************************
// Function		: getPriceName
// Description	: i(ʉݒPʕt)擾
//****************************************************************************
function getPriceName( $inData ) {
	$outStr = "";

	// ʉݒPʂ̃Zbg
	if ( $inData->isSetCurrencyCode() ) {
		switch ( $inData->getCurrencyCode() ) {
			case "JPY":
				$outStr .= "\\";
				break;
			case "USD":
				$outStr .= "$";
				break;
			default:
				$outStr .= "(" . $inData->getCurrencyCode() . ")";
				break;
		}
	}

	// z̃Zbg
	if ($inData->isSetAmount()) {
	    $outStr .= sprintf( "%.0lf", $inData->getAmount() );
	}

	return $outStr;
}
